	cpu LMM
	.module feature.c
	.area text(rom, con, rel)
	.dbfile ./feature.c
	.dbfunc e cmemcmp _cmemcmp fc
;         length -> X-8
;            ram -> X-7
;            rom -> X-5
_cmemcmp::
	.dbline -1
	push X
	mov X,SP
	.dbline 68
; //*****************************************************************************
; //*****************************************************************************
; //  FILENAME:   feature.c
; //  Version: 1.0, 2006/10/24 
; //  Generated by Andy Kiser
; //
; //  DESCRIPTION:  Handling of FEATURE requests
; //
; //  NOTE: The Toradex Definition is based on 32-Bytes Feature reports. 
; // 		  Therefore, the file usb_descr.asm needs to be modified after each
; //        "Generate Application":
; //		  1) USB_INTERFACE_0_FEATURE_RPT_DATA: BLK  32
; //		  2) USB_HID_RPT_1_FEATURE_RPT_SIZE:   EQU  32
; //		  3) Add a Label at the beginning of the string descriptor containing
; //           the USB serial number:
; //				EXPORT _USB_Serial:
; //				_USB_Serial:
; //		  4) Put all the USB string descriptors into 
; //			 ROM area "StringDescriptors"
; //		  5) in usb_drv.asm, add the following label and export it:
; //			 _USB_TransferType  (identical to USB_TranferType, but with 
; //			 					 leading underscore)
; //
; //-----------------------------------------------------------------------------
; //  Copyright (c) Toradex AG 2006. All Rights Reserved.
; //*****************************************************************************
; //*****************************************************************************
; #define __DEBUG__
; #include <m8c.h>        // part specific constants and macros
; #include "feature.h"
; #include "digitalio.h"
; #include "Nonvolatile.h"
; #include "string.h"
; #include "usb.h"
; #include "parameters.h"
; #include "sensor.h"
; 
; //----------------------------------------
; // The following status Variable is modified by the Cypress USB firmware
; //----------------------------------------
; extern BYTE USB_TransferType;
; #define USB_TRANS_STATE_IDLE 0x00
; 
; //----------------------------------------
; // definition for USB serial string
; // 	when replacing the Serial, the length of the new serial MUST equal
; // 	the current string size!
; //----------------------------------------
; #define ANYLENGTH 255
; typedef struct
; {
; 	BYTE	bLength;          // descriptor size in Bytes, including 
; 	BYTE	bDescriptorType;  // must be 3. DO NOT CHANGE
; 	char	UnicodeText[ANYLENGTH]; // Unicode text with little endian byte order
; } tStringDescriptor;
; 
; extern const tStringDescriptor USB_Serial;
; 
; //----------------------------------------
; // - return data
; #define FEAT_RETURN				0xFF
; 
; //-----------------------------------------------------------------------------
; // compare a ROM memory range against a RAM memory range
; // returns TRUE if they are equal
; //-----------------------------------------------------------------------------
; BOOL cmemcmp (const char *rom, char *ram, BYTE length)
; {
	xjmp L11
L10:
	.dbline 70
; 	while (length>0)
; 	{
	.dbline 71
; 		length--;
	dec [X-8]
	.dbline 72
; 		if ( rom[length] != ram[length] )
	mov REG[0xd0],>__r0
	mov A,[X-8]
	mov [__r1],A
	mov [__r0],0
	mov A,[X-6]
	add [__r1],A
	mov A,[X-7]
	adc [__r0],A
	mov A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r0],A
	mov A,[X-8]
	mov [__r3],A
	mov [__r2],0
	mov A,[X-4]
	add [__r3],A
	mov A,[X-5]
	adc [__r2],A
	mov A,[__r2]
	push X
	mov X,[__r3]
	romx
	pop X
	cmp A,[__r0]
	jz L13
	.dbline 73
; 			return FALSE;
	mov A,0
	xjmp L9
L13:
	.dbline 74
L11:
	.dbline 69
	mov A,0
	cmp A,[X-8]
	jc L10
X0:
	.dbline 75
; 	}
; 	return TRUE;
	mov REG[0xd0],>__r0
	mov A,1
	.dbline -2
L9:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l length -8 c
	.dbsym l ram -7 pc
	.dbsym l rom -5 pc
	.dbend
	.dbfunc e Feature_Start _Feature_Start fV
_Feature_Start::
	.dbline -1
	.dbline 81
; }
; //-----------------------------------------------------------------------------
; // Initialize Feature Reporting
; //-----------------------------------------------------------------------------
; void Feature_Start(void)
; {
	.dbline 82
; 	FEATURE_RPT.IN.ReturnCode = 0xFF; // to mark that there is no command pending
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	mov [_USB_INTERFACE_0_FEATURE_RPT_DATA],-1
	.dbline 83
; 	Parameters_Start();
	xcall _Parameters_Start
	.dbline -2
	.dbline 84
; }
L15:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e ProcessFeatureReports _ProcessFeatureReports fV
;             dw -> X+26
;         Result -> X+25
;              w -> X+23
;            txt -> X+2
;              i -> X+1
; NumberOfReturnedBytes -> X+0
_ProcessFeatureReports::
	.dbline -1
	push X
	mov X,SP
	add SP,34
	.dbline 94
; 
; //-----------------------------------------------------------------------------
; // check if feature report is pending
; // if yes:
; //	1) process request
; //  2) prepare return data if appropriate
; //  3) set FSM_FeatureRpt to allow further processing
; //-----------------------------------------------------------------------------
; void ProcessFeatureReports (void)
; {
	.dbline 100
; 	BYTE	Result;
; 	BYTE	i;
; 	char	txt[21];
; 	WORD	w;
; 	DWORD	dw;
; 	BYTE	NumberOfReturnedBytes = 0;
	mov [X+0],0
	.dbline 103
; 
; 	// if return data has been overwritten by a command and SetFeature has finished
; 	if ( (USB_TransferType == USB_TRANS_STATE_IDLE) && (FEATURE_RPT.IN.ReturnCode != 0xFF) )
	mov REG[0xd0],>_USB_TransferType
	cmp [_USB_TransferType],0
	jnz L17
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	cmp [_USB_INTERFACE_0_FEATURE_RPT_DATA],-1
	jz L17
	.dbline 104
; 	{
	.dbline 105
; 		switch (FEATURE_RPT.OUT.Target)
	mov A,[_USB_INTERFACE_0_FEATURE_RPT_DATA+1]
	mov [X+31],A
	mov [X+30],0
	cmp [X+30],0
	jnz X5
	cmp [X+31],0
	jz L23
X5:
	cmp [X+30],0
	jnz X6
	cmp [X+31],1
	jz L23
X6:
	cmp [X+30],0
	jnz X7
	cmp [X+31],2
	jz L133
X7:
	cmp [X+30],0
	jnz X8
	cmp [X+31],3
	jz L151
X8:
	cmp [X+30],0
	jnz X9
	cmp [X+31],4
	jz L151
X9:
	xjmp L19
X1:
	.dbline 106
; 		{
L23:
	.dbline 110
; 			// ---------- target is RAM or Flash ==> standard processing
; 			case eRAM:		
; 			case eFlash:
; 				if (FEATURE_RPT.OUT.Get_nSet)
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	cmp [_USB_INTERFACE_0_FEATURE_RPT_DATA],0
	jz L24
	.dbline 111
; 				{	// ----- GET
	.dbline 112
; 					switch (FEATURE_RPT.OUT.ParamSize)
	mov A,[_USB_INTERFACE_0_FEATURE_RPT_DATA+2]
	mov [X+33],A
	mov [X+32],0
	cmp [X+32],0
	jnz X10
	cmp [X+33],1
	jz L30
X10:
	cmp [X+32],0
	jnz X11
	cmp [X+33],2
	jz L37
X11:
	cmp [X+32],0
	jnz X12
	cmp [X+33],4
	jz L46
X12:
	mov A,[X+33]
	sub A,1
	mov A,[X+32]
	xor A,-128
	sbb A,(0 ^ 0x80)
	jc L20
X13:
L66:
	cmp [X+32],0
	jnz X14
	cmp [X+33],21
	jz L59
X14:
	xjmp L20
X2:
	.dbline 113
; 					{
L30:
	.dbline 115
; 						case   1:
; 							if (FEATURE_RPT.OUT.Index_LSB < NUM_PARAM_8)
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	cmp [_USB_INTERFACE_0_FEATURE_RPT_DATA+3],3
	jnc L20
X15:
	.dbline 116
; 							{
	.dbline 117
; 								Get_Param_8(FEATURE_RPT.OUT.Index_LSB, FEATURE_RPT.OUT.Target, (BYTE*)FEATURE_RPT.IN.Param);
	mov A,>_USB_INTERFACE_0_FEATURE_RPT_DATA+1
	push A
	mov A,<_USB_INTERFACE_0_FEATURE_RPT_DATA+1
	push A
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	mov A,[_USB_INTERFACE_0_FEATURE_RPT_DATA+1]
	push A
	mov A,[_USB_INTERFACE_0_FEATURE_RPT_DATA+3]
	push A
	xcall _Get_Param_8
	add SP,-4
	.dbline 118
; 								NumberOfReturnedBytes = 1;
	mov [X+0],1
	.dbline 119
; 							}
	.dbline 120
; 							break;
	xjmp L20
L37:
	.dbline 123
; 
; 						case  2:
; 							if (FEATURE_RPT.OUT.Index_LSB < NUM_PARAM_16)
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	cmp [_USB_INTERFACE_0_FEATURE_RPT_DATA+3],3
	jnc L20
X16:
	.dbline 124
; 							{
	.dbline 125
; 								Get_Param_16(FEATURE_RPT.OUT.Index_LSB, FEATURE_RPT.OUT.Target, &w);
	mov REG[0xd0],>__r0
	mov [__r1],X
	add [__r1],23
	mov A,3
	push A
	mov A,[__r1]
	push A
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	mov A,[_USB_INTERFACE_0_FEATURE_RPT_DATA+1]
	push A
	mov A,[_USB_INTERFACE_0_FEATURE_RPT_DATA+3]
	push A
	xcall _Get_Param_16
	add SP,-4
	.dbline 126
; 								FEATURE_RPT.IN.Param[0]= w & 0xFF;
	mov A,[X+24]
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	mov [_USB_INTERFACE_0_FEATURE_RPT_DATA+1],A
	.dbline 127
; 								FEATURE_RPT.IN.Param[1]= w / 0x100;
	mov A,[X+23]
	mov [_USB_INTERFACE_0_FEATURE_RPT_DATA+1+1],A
	.dbline 128
; 								NumberOfReturnedBytes = 2;
	mov [X+0],2
	.dbline 129
; 							}
	.dbline 130
; 							break;
	xjmp L20
L46:
	.dbline 133
; 
; 						case  4:
; 							if (FEATURE_RPT.OUT.Index_LSB < NUM_PARAM_32)
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	cmp [_USB_INTERFACE_0_FEATURE_RPT_DATA+3],1
	jnc L20
X17:
	.dbline 134
; 							{
	.dbline 135
; 								Get_Param_32(FEATURE_RPT.OUT.Index_LSB, FEATURE_RPT.OUT.Target, &dw);
	mov REG[0xd0],>__r0
	mov [__r1],X
	add [__r1],26
	mov A,3
	push A
	mov A,[__r1]
	push A
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	mov A,[_USB_INTERFACE_0_FEATURE_RPT_DATA+1]
	push A
	mov A,[_USB_INTERFACE_0_FEATURE_RPT_DATA+3]
	push A
	xcall _Get_Param_32
	add SP,-4
	.dbline 136
; 								FEATURE_RPT.IN.Param[0]=  w        & 0xFF;
	mov A,[X+24]
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	mov [_USB_INTERFACE_0_FEATURE_RPT_DATA+1],A
	.dbline 137
; 								FEATURE_RPT.IN.Param[1]= (w / 0x100) & 0xFF;
	mov REG[0xd0],>__r0
	mov A,[X+23]
	mov [__r0],0
	and [__r0],0
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	mov [_USB_INTERFACE_0_FEATURE_RPT_DATA+1+1],A
	.dbline 138
; 								FEATURE_RPT.IN.Param[2]= (w / 0x10000) & 0xFF;
	mov REG[0xd0],>__r0
	mov A,[X+24]
	mov [__r3],A
	mov A,[X+23]
	mov [__r2],A
	mov A,0
	push A
	mov A,1
	push A
	mov A,0
	push A
	push A
	push A
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	xcall __divmod_32X32_32
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	mov [__r0],A
	add SP,-4
	and [__r2],0
	and [__r1],0
	and [__r0],0
	mov A,[__r3]
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	mov [_USB_INTERFACE_0_FEATURE_RPT_DATA+1+2],A
	.dbline 139
; 								FEATURE_RPT.IN.Param[3]= (w / 0x1000000) & 0xFF;
	mov REG[0xd0],>__r0
	mov A,[X+24]
	mov [__r3],A
	mov A,[X+23]
	mov [__r2],A
	mov A,1
	push A
	mov A,0
	push A
	push A
	push A
	push A
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	xcall __divmod_32X32_32
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	mov [__r0],A
	add SP,-4
	and [__r2],0
	and [__r1],0
	and [__r0],0
	mov A,[__r3]
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	mov [_USB_INTERFACE_0_FEATURE_RPT_DATA+1+3],A
	.dbline 140
; 								NumberOfReturnedBytes = 4;
	mov [X+0],4
	.dbline 141
; 							}
	.dbline 142
; 							break;
	xjmp L20
L59:
	.dbline 145
; 
; 						case 21:
; 							if (FEATURE_RPT.OUT.Index_LSB < NUM_PARAM_168)
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	cmp [_USB_INTERFACE_0_FEATURE_RPT_DATA+3],3
	jnc L20
X18:
	.dbline 146
; 							{
	.dbline 147
; 								Get_Param_168(FEATURE_RPT.OUT.Index_LSB, FEATURE_RPT.OUT.Target, FEATURE_RPT.IN.Param);
	mov A,>_USB_INTERFACE_0_FEATURE_RPT_DATA+1
	push A
	mov A,<_USB_INTERFACE_0_FEATURE_RPT_DATA+1
	push A
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	mov A,[_USB_INTERFACE_0_FEATURE_RPT_DATA+1]
	push A
	mov A,[_USB_INTERFACE_0_FEATURE_RPT_DATA+3]
	push A
	xcall _Get_Param_168
	add SP,-4
	.dbline 148
; 								NumberOfReturnedBytes = 21;
	mov [X+0],21
	.dbline 149
; 							}
	.dbline 150
; 							break;
	.dbline 152
; 					}
; 				}
	xjmp L20
L24:
	.dbline 154
; 				else	
; 				{	// ----- SET
	.dbline 155
; 					switch (FEATURE_RPT.OUT.ParamSize)
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	mov A,[_USB_INTERFACE_0_FEATURE_RPT_DATA+2]
	mov [X+33],A
	mov [X+32],0
	cmp [X+32],0
	jnz X19
	cmp [X+33],1
	jz L71
X19:
	cmp [X+32],0
	jnz X20
	cmp [X+33],2
	jz L78
X20:
	cmp [X+32],0
	jnz X21
	cmp [X+33],4
	jz L87
X21:
	mov A,[X+33]
	sub A,1
	mov A,[X+32]
	xor A,-128
	sbb A,(0 ^ 0x80)
	jc L67
X22:
L132:
	cmp [X+32],0
	jnz X23
	cmp [X+33],20
	jz L107
X23:
	cmp [X+32],0
	jnz X24
	cmp [X+33],21
	jz L100
X24:
	xjmp L67
X3:
	.dbline 156
; 					{
L71:
	.dbline 158
; 						case   1:
; 							if (FEATURE_RPT.OUT.Index_LSB < NUM_PARAM_8)
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	cmp [_USB_INTERFACE_0_FEATURE_RPT_DATA+3],3
	jnc L68
X25:
	.dbline 159
; 								Set_Param_8(FEATURE_RPT.OUT.Index_LSB, FEATURE_RPT.OUT.Target, FEATURE_RPT.OUT.Param[0]);
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	mov A,[_USB_INTERFACE_0_FEATURE_RPT_DATA+5]
	push A
	mov A,[_USB_INTERFACE_0_FEATURE_RPT_DATA+1]
	push A
	mov A,[_USB_INTERFACE_0_FEATURE_RPT_DATA+3]
	push A
	xcall _Set_Param_8
	add SP,-3
	.dbline 160
; 							break;
	xjmp L68
L78:
	.dbline 163
; 						
; 						case  2:
; 							if (FEATURE_RPT.OUT.Index_LSB < NUM_PARAM_16)
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	cmp [_USB_INTERFACE_0_FEATURE_RPT_DATA+3],3
	jnc L68
X26:
	.dbline 164
; 								Set_Param_16(FEATURE_RPT.OUT.Index_LSB, FEATURE_RPT.OUT.Target, FEATURE_RPT.OUT.Param[0]+256*FEATURE_RPT.OUT.Param[1]);
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	mov A,[_USB_INTERFACE_0_FEATURE_RPT_DATA+5+1]
	mov REG[0xd0],>__r0
	mov [__r0],A
	mov [__r1],0
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	mov A,[_USB_INTERFACE_0_FEATURE_RPT_DATA+5]
	mov REG[0xd0],>__r0
	add A,[__r1]
	mov [__r1],A
	mov A,0
	adc A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	mov A,[_USB_INTERFACE_0_FEATURE_RPT_DATA+1]
	push A
	mov A,[_USB_INTERFACE_0_FEATURE_RPT_DATA+3]
	push A
	xcall _Set_Param_16
	add SP,-4
	.dbline 165
; 							break;
	xjmp L68
L87:
	.dbline 168
; 						
; 						case  4:
; 							if (FEATURE_RPT.OUT.Index_LSB < NUM_PARAM_32)
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	cmp [_USB_INTERFACE_0_FEATURE_RPT_DATA+3],1
	jnc L68
X27:
	.dbline 169
; 								Set_Param_32(FEATURE_RPT.OUT.Index_LSB, FEATURE_RPT.OUT.Target, 
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	mov A,[_USB_INTERFACE_0_FEATURE_RPT_DATA+5+3]
	mov REG[0xd0],>__r0
	mov [__r3],A
	mov [__r2],0
	mov [__r1],0
	mov [__r0],0
	mov A,24
X28:
	mov REG[0xd0],>__r0
	asl [__r3]
	rlc [__r2]
	rlc [__r1]
	rlc [__r0]
	dec A
	jnz X28
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	mov A,[_USB_INTERFACE_0_FEATURE_RPT_DATA+5+2]
	mov REG[0xd0],>__r0
	mov [__r7],A
	mov [__r6],0
	mov [__r5],0
	mov [__r4],0
	mov A,16
X29:
	mov REG[0xd0],>__r0
	asl [__r7]
	rlc [__r6]
	rlc [__r5]
	rlc [__r4]
	dec A
	jnz X29
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	mov A,[_USB_INTERFACE_0_FEATURE_RPT_DATA+5+1]
	mov REG[0xd0],>__r0
	mov [__r8],A
	mov [__r9],0
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	mov A,[_USB_INTERFACE_0_FEATURE_RPT_DATA+5]
	mov REG[0xd0],>__r0
	add A,[__r9]
	mov [__r9],A
	mov A,0
	adc A,[__r8]
	mov [__r8],A
	mov A,[__r9]
	mov [__r11],A
	mov A,[__r8]
	mov [__r10],A
	tst [__r10],-128
	jz X30
	mov [__r9],-1
	mov [__r8],-1
	jmp X31
X30:
	mov REG[0xd0],>__r0
	mov [__r9],0
	mov [__r8],0
X31:
	mov REG[0xd0],>__r0
	mov A,[__r11]
	add A,[__r7]
	mov [__r7],A
	mov A,[__r10]
	adc A,[__r6]
	mov [__r6],A
	mov A,[__r9]
	adc A,[__r5]
	mov [__r5],A
	mov A,[__r8]
	adc A,[__r4]
	mov [__r4],A
	mov A,[__r7]
	add A,[__r3]
	mov [__r3],A
	mov A,[__r6]
	adc A,[__r2]
	mov [__r2],A
	mov A,[__r5]
	adc A,[__r1]
	mov [__r1],A
	mov A,[__r4]
	adc A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	mov A,[_USB_INTERFACE_0_FEATURE_RPT_DATA+1]
	push A
	mov A,[_USB_INTERFACE_0_FEATURE_RPT_DATA+3]
	push A
	xcall _Set_Param_32
	add SP,-6
	.dbline 171
; 								             FEATURE_RPT.OUT.Param[0]+0x100*FEATURE_RPT.OUT.Param[1]+0x10000*FEATURE_RPT.OUT.Param[2]+0x1000000*FEATURE_RPT.OUT.Param[3]);
; 							break;
	xjmp L68
L100:
	.dbline 174
; 						
; 						case 21:
; 							if (FEATURE_RPT.OUT.Index_LSB < NUM_PARAM_168)
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	cmp [_USB_INTERFACE_0_FEATURE_RPT_DATA+3],3
	jnc L68
X32:
	.dbline 175
; 								Set_Param_168(FEATURE_RPT.OUT.Index_LSB, FEATURE_RPT.OUT.Target, FEATURE_RPT.OUT.Param);
	mov A,>_USB_INTERFACE_0_FEATURE_RPT_DATA+5
	push A
	mov A,<_USB_INTERFACE_0_FEATURE_RPT_DATA+5
	push A
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	mov A,[_USB_INTERFACE_0_FEATURE_RPT_DATA+1]
	push A
	mov A,[_USB_INTERFACE_0_FEATURE_RPT_DATA+3]
	push A
	xcall _Set_Param_168
	add SP,-4
	.dbline 176
; 							break;
	xjmp L68
L107:
	.dbline 179
; 						
; 						case 20: // only for "set USB serial"
; 							if (( cmemcmp ("USBSN", &FEATURE_RPT.OUT.Param[0], 5) ) && ( USB_Serial.bLength == FEATURE_RPT.OUT.Param[5] ))
	mov A,5
	push A
	mov A,>_USB_INTERFACE_0_FEATURE_RPT_DATA+5
	push A
	mov A,<_USB_INTERFACE_0_FEATURE_RPT_DATA+5
	push A
	mov A,>L110
	push A
	mov A,<L110
	push A
	xcall _cmemcmp
	add SP,-5
	cmp A,0
	jz L108
	mov A,>_USB_Serial
	push X
	mov X,<_USB_Serial
	romx
	pop X
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	cmp A,[_USB_INTERFACE_0_FEATURE_RPT_DATA+5+5]
	jnz L108
	.dbline 181
; 								// modify USB serial number
; 								Result = Flash_Modify ((const BYTE*)&USB_Serial, &FEATURE_RPT.OUT.Param[5], USB_Serial.bLength);
	mov REG[0xd0],>__r0
	mov A,>_USB_Serial
	push X
	mov X,<_USB_Serial
	romx
	pop X
	push A
	mov A,>_USB_INTERFACE_0_FEATURE_RPT_DATA+5+5
	push A
	mov A,<_USB_INTERFACE_0_FEATURE_RPT_DATA+5+5
	push A
	mov A,>_USB_Serial
	push A
	mov A,<_USB_Serial
	push A
	xcall _Flash_Modify
	add SP,-5
	mov REG[0xd0],>__r0
	mov [X+25],A
L108:
	.dbline 184
; 								
; 							// reset all parameters to factory defaults, even if the security bytes above are incorrect
; 							for (i=0; i < NUM_PARAM_8; i++)
	mov [X+1],0
	xjmp L119
L116:
	.dbline 185
	mov REG[0xd0],>__r0
	mov A,[X+1]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_FactoryDefault_Param_8
	adc [__r0],>_FactoryDefault_Param_8
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	push A
	mov A,1
	push A
	mov A,[X+1]
	push A
	xcall _Set_Param_8
	add SP,-3
L117:
	.dbline 184
	inc [X+1]
L119:
	.dbline 184
	cmp [X+1],3
	jc L116
X33:
	.dbline 186
; 								Set_Param_8( i, NONVOLATILE, FactoryDefault_Param_8[i] );
; 							for (i=0; i < NUM_PARAM_16; i++)
	mov [X+1],0
	xjmp L123
L120:
	.dbline 187
	mov REG[0xd0],>__r0
	mov A,[X+1]
	mov [__r1],A
	mov [__r0],0
	asl [__r1]
	rlc [__r0]
	add [__r1],<_FactoryDefault_Param_16
	adc [__r0],>_FactoryDefault_Param_16
	mov A,[__r0]
	push X
	push A
	mov X,[__r1]
	romx
	mov [__r0],A
	pop A
	inc X
	adc A,0
	romx
	mov [__r1],A
	pop X
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,1
	push A
	mov A,[X+1]
	push A
	xcall _Set_Param_16
	add SP,-4
L121:
	.dbline 186
	inc [X+1]
L123:
	.dbline 186
	cmp [X+1],3
	jc L120
X34:
	.dbline 188
; 								Set_Param_16( i, NONVOLATILE, FactoryDefault_Param_16[i] );
; 							for (i=0; i < NUM_PARAM_32; i++)
	mov [X+1],0
	xjmp L127
L124:
	.dbline 189
	mov REG[0xd0],>__r0
	mov A,[X+1]
	mov [__r1],A
	mov [__r0],0
	asl [__r1]
	rlc [__r0]
	asl [__r1]
	rlc [__r0]
	add [__r1],<_FactoryDefault_Param_32
	adc [__r0],>_FactoryDefault_Param_32
	mov A,[__r0]
	push X
	push A
	mov X,[__r1]
	romx
	mov [__r0],A
	pop A
	inc X
	adc A,0
	push A
	romx
	mov [__r1],A
	pop A
	inc X
	adc A,0
	push A
	romx
	mov [__r2],A
	pop A
	inc X
	adc A,0
	romx
	mov [__r3],A
	pop X
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	mov A,1
	push A
	mov A,[X+1]
	push A
	xcall _Set_Param_32
	add SP,-6
L125:
	.dbline 188
	inc [X+1]
L127:
	.dbline 188
	cmp [X+1],1
	jc L124
X35:
	.dbline 190
; 								Set_Param_32( i, NONVOLATILE, FactoryDefault_Param_32[i] );
; 							for (i=0; i < NUM_PARAM_168; i++)
	mov [X+1],0
	xjmp L131
L128:
	.dbline 191
	.dbline 192
	mov A,0
	push A
	mov A,20
	push A
	mov REG[0xd0],>__r0
	mov A,[X+1]
	mov [__r1],A
	mov A,0
	push A
	mov A,[__r1]
	push A
	mov A,0
	push A
	mov A,21
	push A
	xcall __mul16
	add SP,-4
	mov A,[__rX]
	mov [__r1],A
	mov A,[__rY]
	mov [__r0],A
	add [__r1],<_FactoryDefault_Param_168
	adc [__r0],>_FactoryDefault_Param_168
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov [__r1],X
	add [__r1],2
	mov A,3
	push A
	mov A,[__r1]
	push A
	xcall _cstrncpy
	.dbline 193
	mov REG[0xd0],>__r0
	mov [__r1],X
	add [__r1],2
	mov A,3
	push A
	mov A,[__r1]
	push A
	mov A,1
	push A
	mov A,[X+1]
	push A
	xcall _Set_Param_168
	add SP,-10
	.dbline 194
L129:
	.dbline 190
	inc [X+1]
L131:
	.dbline 190
	cmp [X+1],3
	jc L128
X36:
	.dbline 196
; 							{
; 								cstrncpy(txt, FactoryDefault_Param_168[i], 20); // copy from Flash to RAM (necessary due to Harvard architecture)
; 								Set_Param_168( i, NONVOLATILE, txt );
; 							}
; 
; 							break;
L67:
L68:
	.dbline 198
; 					}
; 					NumberOfReturnedBytes = 0;
	mov [X+0],0
	.dbline 199
; 					Sensor_Specific_Parameter(&NumberOfReturnedBytes);  // Allows for special treatment at the end of Parameter Set / Get command.
	mov REG[0xd0],>__r0
	mov A,3
	push A
	push X
	xcall _Sensor_Specific_Parameter
	add SP,-2
	.dbline 200
; 				}	
	.dbline 201
; 				break;	
	xjmp L20
L133:
	.dbline 205
; 			
; 			// ---------- special Treatment for Parameters outside of Flash or RAM
; 			case eController:	
; 				switch (FEATURE_RPT.OUT.Index_LSB)
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	mov A,[_USB_INTERFACE_0_FEATURE_RPT_DATA+3]
	mov [X+33],A
	mov [X+32],0
	cmp [X+32],0
	jnz X37
	cmp [X+33],0
	jz L138
X37:
	xjmp L134
X4:
	.dbline 206
; 				{
L138:
	.dbline 208
; 					case 0:
; 						if ( (FEATURE_RPT.OUT.Index_LSB ==0) && (FEATURE_RPT.OUT.ParamSize == 3) )
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	cmp [_USB_INTERFACE_0_FEATURE_RPT_DATA+3],0
	jnz L139
	cmp [_USB_INTERFACE_0_FEATURE_RPT_DATA+2],3
	jnz L139
	.dbline 209
; 							if ( FEATURE_RPT.OUT.Get_nSet )
	cmp [_USB_INTERFACE_0_FEATURE_RPT_DATA],0
	jz L143
	.dbline 210
; 								FEATURE_RPT.IN.Param[0] = DigitalIn_Get();
	xcall _DigitalIn_Get
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	mov [_USB_INTERFACE_0_FEATURE_RPT_DATA+1],A
	xjmp L144
L143:
	.dbline 212
; 							else
; 								DigitalOut_Set (FEATURE_RPT.OUT.Param[0], FEATURE_RPT.OUT.Param[1], FEATURE_RPT.OUT.Param[2]);
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	mov A,[_USB_INTERFACE_0_FEATURE_RPT_DATA+5+2]
	push A
	mov A,[_USB_INTERFACE_0_FEATURE_RPT_DATA+5+1]
	push A
	mov A,[_USB_INTERFACE_0_FEATURE_RPT_DATA+5]
	push A
	xcall _DigitalOut_Set
	add SP,-3
L144:
L139:
	.dbline 213
; 						NumberOfReturnedBytes = 0;
	mov [X+0],0
	.dbline 214
; 						break;	
	xjmp L135
L134:
	.dbline 217
; 						
; 					default:
; 						NumberOfReturnedBytes = Sensor_Specific_Feature();
	xcall _Sensor_Specific_Feature
	mov REG[0xd0],>__r0
	mov [X+0],A
	.dbline 218
; 						break;
L135:
L151:
	.dbline 223
; 				}
; 			
; 			case eSensor:
; 			case eAction:
; 				NumberOfReturnedBytes = Sensor_Specific_Feature();
	xcall _Sensor_Specific_Feature
	mov REG[0xd0],>__r0
	mov [X+0],A
	.dbline 224
; 				break;
L19:
L20:
	.dbline 229
	mov REG[0xd0],>__r0
	mov A,[X+0]
	mov [__r1],A
	mov [__r0],0
	mov A,31
	sub A,[__r1]
	mov [__r1],A
	mov A,0
	sbb A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,0
	push A
	mov A,-86
	push A
	mov A,[X+0]
	mov [__r1],A
	add [__r1],<_USB_INTERFACE_0_FEATURE_RPT_DATA+1
	adc [__r0],>_USB_INTERFACE_0_FEATURE_RPT_DATA+1
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	xcall _memsetLMM
	add SP,-6
	.dbline 230
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	mov [_USB_INTERFACE_0_FEATURE_RPT_DATA],-1
	.dbline 231
L17:
	.dbline -2
	.dbline 232
; 
; 		}	
; 		
; 		// clear unused part of report to 0x00
; 		memset(&FEATURE_RPT.IN.Param[NumberOfReturnedBytes], 0xAA, 31-NumberOfReturnedBytes);
; 		FEATURE_RPT.IN.ReturnCode = 0xFF;
; 	}
; }
L16:
	add SP,-34
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l dw 26 l
	.dbsym l Result 25 c
	.dbsym l w 23 i
	.dbsym l txt 2 A[21:21]c
	.dbsym l i 1 c
	.dbsym l NumberOfReturnedBytes 0 c
	.dbend
	.area lit(rom, con, rel)
L110:
	.byte 'U,'S,'B,'S,'N,0
